// controls

import * as Inputs from "npm:@observablehq/inputs";
import random from "npm:random";
import * as d3 from "npm:d3-color";

const PALETTES = new Map([
	[ "random RGB", palette_random ], 
	[ "grayscale", palette_grayscale ],
    [ "monochrome", palette_monochrome ],
]);

	// monochrome
	// one spot
	// two spot
 	// RGB
 	// CMY
 	// RYB
 	// triad - full saturation
 	// triad - pastel
 	// trial - dusk
 	// random HSV
 	// random RGB

function palette_random() {
	const u = random.uniform(0, 255);
	return [1,2,3].map((x)=> d3.rgb(u(), u(), u()));
}


function palette_grayscale() {
	const u = random.uniform(0, 1);
	return [1,2,3].map((x)=> d3.hsl(0, 0, u()));
}

function palette_monochrome() {
	const u = random.uniform(0, 1);
	const h = u() * 360;
	return [1,2,3].map((x)=> d3.hsl(h, u(), u()));
}


class DotControls {

	constructor(fg, radius_opts) {	
		this.radius_opts = radius_opts;
		this.fg = Inputs.color({label: "colour", value: fg});
		this.m = Inputs.range([1, 5], {value: 2, step: 1, label:"m"});
		this.n = Inputs.range([1, 5], {value: 2, step: 1, label:"n"});
		this.r = Inputs.range([0, 0.4], {value: 0.2, step: 0.01, label: "radius"});
		this.f = Inputs.select(radius_opts, {label: "gradient", value: radius_opts[0]});
	}

	random_grid() {
		this.m.value = random.choice([1, 2, 3, 4, 5]);	
		this.n.value = random.choice([1, 2, 3, 4, 5]);
		this.r.value = random.float(0, 0.4);
		this.f.value = random.choice(this.radius_opts);
		this.m.dispatchEvent(new Event("input"));
		this.n.dispatchEvent(new Event("input"));
		this.r.dispatchEvent(new Event("input"));
		this.f.dispatchEvent(new Event("input"));
	}

	random_colours() {
		this.set_colour(random_colour());
	}

	set_colour(c) {
		this.fg.value = c;
		this.fg.dispatchEvent(new Event("input"));
	}


}

export { DotControls, PALETTES };